
package inject;

import com.sun.grizzly.http.SelectorThread;
import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.WebResource;
import junit.framework.TestCase;


public class MainTest extends TestCase {

    private SelectorThread threadSelector;
    
    private WebResource r;

    public MainTest(String testName) {
        super(testName);
    }

    @Override
    protected void setUp() throws Exception {
        super.setUp();
        
        threadSelector = Main.startServer();

        Client c = Client.create();
        r = c.resource(Main.BASE_URI);
    }

    @Override
    protected void tearDown() throws Exception {
        super.tearDown();

        threadSelector.stopEndpoint();
    }

    public void testPerRequest() {
        WebResource qr = r.path("per-request").queryParam("v", "1").queryParam("v", "2");

        assertEquals("3", qr.get(String.class));
        assertEquals("3", qr.get(String.class));
    }

    public void testPerSingleton() {
        WebResource qr = r.path("singleton").queryParam("v", "1").queryParam("v", "2");

        assertEquals("3", qr.get(String.class));
        assertEquals("3", qr.get(String.class));
    }
}
